'Copyright (c) 2013 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Collections
Imports Microsoft.VisualBasic
Imports System.Xml

Module modCyborgImplant

    ' These have 2-4 fixed skills (more like symbiants) but variable QL (like implants)

    ' base array
    Public CyborgImplantName() As String = { _
      "", "Cyborg Head Implant", "", "Cyborg Arm Implant", "Cyborg Chest Implant", "Cyborg Arm Implant", "Cyborg Wrist Implant", "Cyborg Waist Implant", "Cyborg Wrist Implant", "", "Cyborg Leg Implant", "", "" _
    }

    ' thse are the QL1s [0] and QL200 [1] AOIDs
    Public CyborgImplantAOID(,) As Integer = { _
      {0, 164824, 0, 164831, 164825, 164831, 164833, 164827, 164833, 0, 164829, 0, 0}, _
      {0, 164823, 0, 164832, 164826, 164832, 164834, 164828, 164834, 0, 164830, 0, 0} _
    }

    Public Function checkBreedCyborgImplant(ByVal breed_id As Integer) As Boolean
        If breed_id = ATROX_ID Then
            Return True
        End If
        Return False
    End Function

    Public Function checkSlotCyborgImplant(ByVal slot_id As Integer) As Boolean
        If slot_id = 0 Or slot_id = 2 Or slot_id = 9 Or slot_id = 11 Then
            Return False
        End If
        Return True
    End Function

    Function getCyborgImplantTooltip(ByVal lo_aoid As Integer, ByVal hi_aoid As Integer, ByVal ql As Integer) As String
        Dim s As String
        Dim j As Integer
        Dim tmpMods(NUM_SKILLS + NUM_ATTRS + 1) As Integer

        getItemModifiers(lo_aoid, hi_aoid, ql, tmpMods)
        For j = 0 To NUM_SKILLS - 1
            If tmpMods(j) <> 0 Then
                s &= "#" & skillNames(j) & " : " & tmpMods(j)
            End If
        Next
        For j = 0 To NUM_ATTRS - 1
            If tmpMods(j) <> 0 Then
                s &= "#" & attrNames(j) & " : " & tmpMods(j + NUM_SKILLS)
            End If
        Next
        If tmpMods(NUM_SKILLS + NUM_ATTRS) <> 0 Then
            s &= "#" & "Max Health" & " : " & tmpMods(j + NUM_SKILLS)
        End If
        If tmpMods(NUM_SKILLS + NUM_ATTRS + 1) <> 0 Then
            s &= "#" & "Max Nano" & " : " & tmpMods(j + NUM_SKILLS)
        End If
        s = s.Substring(1)
        s = s.Replace("#", Chr(10))
        Return s
    End Function

End Module
