'Copyright (c) 2009-2013 Donald Milne
'All rights reserved.
'
'This file is part of CharacterParser.
'
'CharacterParser is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'CharacterParser is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with CharacterParser.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Threading
Imports Microsoft.VisualBasic

Public Class frmMain

    Inherits System.Windows.Forms.Form

    Private home_path As String

    Public Delegate Sub updateUITextDelegateType(ByVal msg As String)
    Public Delegate Sub updateUIVoidDelegateType()

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents cmdSelect As System.Windows.Forms.Button
    Friend WithEvents ofdSelect As System.Windows.Forms.OpenFileDialog
    Friend WithEvents txtCharName As System.Windows.Forms.TextBox
    Friend WithEvents chkDebug As System.Windows.Forms.CheckBox
    Friend WithEvents txtStatus As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cmdSelect = New System.Windows.Forms.Button
        Me.ofdSelect = New System.Windows.Forms.OpenFileDialog
        Me.txtCharName = New System.Windows.Forms.TextBox
        Me.txtStatus = New System.Windows.Forms.Label
        Me.chkDebug = New System.Windows.Forms.CheckBox
        Me.SuspendLayout()
        '
        'cmdSelect
        '
        Me.cmdSelect.CausesValidation = False
        Me.cmdSelect.Location = New System.Drawing.Point(447, 6)
        Me.cmdSelect.Name = "cmdSelect"
        Me.cmdSelect.Size = New System.Drawing.Size(75, 23)
        Me.cmdSelect.TabIndex = 2
        Me.cmdSelect.Text = "Select"
        '
        'txtCharName
        '
        Me.txtCharName.Enabled = False
        Me.txtCharName.Location = New System.Drawing.Point(8, 7)
        Me.txtCharName.Name = "txtCharName"
        Me.txtCharName.Size = New System.Drawing.Size(432, 20)
        Me.txtCharName.TabIndex = 1
        '
        'txtStatus
        '
        Me.txtStatus.Location = New System.Drawing.Point(8, 32)
        Me.txtStatus.Name = "txtStatus"
        Me.txtStatus.Size = New System.Drawing.Size(432, 20)
        Me.txtStatus.TabIndex = 3
        Me.txtStatus.Text = "Ready."
        '
        'chkDebug
        '
        Me.chkDebug.AutoSize = True
        Me.chkDebug.Location = New System.Drawing.Point(447, 32)
        Me.chkDebug.Name = "chkDebug"
        Me.chkDebug.Size = New System.Drawing.Size(64, 17)
        Me.chkDebug.TabIndex = 4
        Me.chkDebug.Text = "Debug?"
        Me.chkDebug.UseVisualStyleBackColor = True
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(528, 51)
        Me.Controls.Add(Me.chkDebug)
        Me.Controls.Add(Me.cmdSelect)
        Me.Controls.Add(Me.txtCharName)
        Me.Controls.Add(Me.txtStatus)
        Me.MaximizeBox = False
        Me.Name = "frmMain"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
        Me.Text = "Character Parser v2.03"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub cmdSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSelect.Click
        ' initialise and show file dialog
        ofdSelect.InitialDirectory = home_path & "\binfiles"
        ofdSelect.RestoreDirectory = True
        ofdSelect.Filter = "bin files (*.bin)|*.bin"
        ofdSelect.RestoreDirectory = True
        ofdSelect.ShowDialog()
        txtCharName.Text = ofdSelect.FileName
        ' handle this as a helper thread
        Dim instance As New System.Windows.Forms.MethodInvoker(AddressOf processFileThread)
        Me.cmdSelect.Enabled = False
        instance.BeginInvoke(Nothing, Nothing)
    End Sub

    ' parameterless subroutine for helper thread
    Private Sub processFileThread()
        processFile(home_path, System.IO.Path.GetFileName(ofdSelect.FileName))
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.MaximumSize = New System.Drawing.Size(Me.Size.Width, Me.Size.Height)
        Me.MinimumSize = New System.Drawing.Size(Me.Size.Width, Me.Size.Height)
        Me.Text = My.Application.Info.Title
        home_path = CurDir()
        ' load perk map, failure here is a hard error and will cause the application to exit
        loadPerkMapXML()
    End Sub

    ' functions to update UI via delegates
    Public Sub updateStatusD(ByVal msg As String)
        objFrmMain.txtStatus.Text = msg
    End Sub

    Public Sub showMsgBoxD(ByVal msg As String)
        MsgBox(msg, MsgBoxStyle.OkOnly, "Character Parser")
    End Sub

    Public Sub enableButtonD()
        objFrmMain.cmdSelect.Enabled = True
    End Sub

End Class
